package com.neusoft.smart.pos.inventory.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class InventoryStoreInoutExample {
    
    protected String orderByClause;
    
    protected boolean distinct;
    
    protected List<Criteria> oredCriteria;
    
    private Integer offset;
    
    private Integer limit;
    
    public InventoryStoreInoutExample() {
        oredCriteria = new ArrayList<Criteria>();
    }
    
    public String getOrderByClause() {
        return orderByClause;
    }
    
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }
    
    public boolean isDistinct() {
        return distinct;
    }
    
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }
    
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }
    
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }
    
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }
    
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }
    
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }
    
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }
    
    public Integer getOffset() {
        return this.offset;
    }
    
    public void setOffset(Integer offset) {
        this.offset = offset;
    }
    
    public Integer getLimit() {
        return this.limit;
    }
    
    public void setLimit(Integer limit) {
        this.limit = limit;
    }
    
    public InventoryStoreInoutExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }
    
    protected abstract static class GeneratedCriteria {
        
        protected List<Criterion> criteria;
        
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }
        
        public boolean isValid() {
            return criteria.size() > 0;
        }
        
        public List<Criterion> getAllCriteria() {
            return criteria;
        }
        
        public List<Criterion> getCriteria() {
            return criteria;
        }
        
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }
        
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }
        
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }
        
        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }
        
        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }
        
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNull() {
            addCriterion("shop_id is null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNotNull() {
            addCriterion("shop_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("shop_id =", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("shop_id <>", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("shop_id >", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_id >=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("shop_id <", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("shop_id <=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("shop_id in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("shop_id not in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdEqualTo(Integer value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotEqualTo(Integer value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThan(Integer value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThan(Integer value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIn(List<Integer> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotIn(List<Integer> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdIsNull() {
            addCriterion("batch_id is null");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdIsNotNull() {
            addCriterion("batch_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdEqualTo(Integer value) {
            addCriterion("batch_id =", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdNotEqualTo(Integer value) {
            addCriterion("batch_id <>", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdGreaterThan(Integer value) {
            addCriterion("batch_id >", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("batch_id >=", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdLessThan(Integer value) {
            addCriterion("batch_id <", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdLessThanOrEqualTo(Integer value) {
            addCriterion("batch_id <=", value, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdIn(List<Integer> values) {
            addCriterion("batch_id in", values, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdNotIn(List<Integer> values) {
            addCriterion("batch_id not in", values, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdBetween(Integer value1, Integer value2) {
            addCriterion("batch_id between", value1, value2, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andBatchIdNotBetween(Integer value1, Integer value2) {
            addCriterion("batch_id not between", value1, value2, "batchId");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIsNull() {
            addCriterion("residue_num is null");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIsNotNull() {
            addCriterion("residue_num is not null");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumEqualTo(BigDecimal value) {
            addCriterion("residue_num =", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotEqualTo(BigDecimal value) {
            addCriterion("residue_num <>", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumGreaterThan(BigDecimal value) {
            addCriterion("residue_num >", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("residue_num >=", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumLessThan(BigDecimal value) {
            addCriterion("residue_num <", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("residue_num <=", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIn(List<BigDecimal> values) {
            addCriterion("residue_num in", values, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotIn(List<BigDecimal> values) {
            addCriterion("residue_num not in", values, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("residue_num between", value1, value2, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("residue_num not between", value1, value2, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIsNull() {
            addCriterion("var_num is null");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIsNotNull() {
            addCriterion("var_num is not null");
            return (Criteria) this;
        }
        
        public Criteria andVarNumEqualTo(BigDecimal value) {
            addCriterion("var_num =", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotEqualTo(BigDecimal value) {
            addCriterion("var_num <>", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumGreaterThan(BigDecimal value) {
            addCriterion("var_num >", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("var_num >=", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumLessThan(BigDecimal value) {
            addCriterion("var_num <", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("var_num <=", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIn(List<BigDecimal> values) {
            addCriterion("var_num in", values, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotIn(List<BigDecimal> values) {
            addCriterion("var_num not in", values, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("var_num between", value1, value2, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("var_num not between", value1, value2, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIsNull() {
            addCriterion("in_price is null");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIsNotNull() {
            addCriterion("in_price is not null");
            return (Criteria) this;
        }
        
        public Criteria andInPriceEqualTo(BigDecimal value) {
            addCriterion("in_price =", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotEqualTo(BigDecimal value) {
            addCriterion("in_price <>", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceGreaterThan(BigDecimal value) {
            addCriterion("in_price >", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("in_price >=", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceLessThan(BigDecimal value) {
            addCriterion("in_price <", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("in_price <=", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIn(List<BigDecimal> values) {
            addCriterion("in_price in", values, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotIn(List<BigDecimal> values) {
            addCriterion("in_price not in", values, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("in_price between", value1, value2, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("in_price not between", value1, value2, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIsNull() {
            addCriterion("sale_price is null");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIsNotNull() {
            addCriterion("sale_price is not null");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceEqualTo(BigDecimal value) {
            addCriterion("sale_price =", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotEqualTo(BigDecimal value) {
            addCriterion("sale_price <>", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceGreaterThan(BigDecimal value) {
            addCriterion("sale_price >", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sale_price >=", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceLessThan(BigDecimal value) {
            addCriterion("sale_price <", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sale_price <=", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIn(List<BigDecimal> values) {
            addCriterion("sale_price in", values, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotIn(List<BigDecimal> values) {
            addCriterion("sale_price not in", values, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sale_price between", value1, value2, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sale_price not between", value1, value2, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIsNull() {
            addCriterion("action_dire is null");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIsNotNull() {
            addCriterion("action_dire is not null");
            return (Criteria) this;
        }
        
        public Criteria andActionDireEqualTo(Integer value) {
            addCriterion("action_dire =", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotEqualTo(Integer value) {
            addCriterion("action_dire <>", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireGreaterThan(Integer value) {
            addCriterion("action_dire >", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireGreaterThanOrEqualTo(Integer value) {
            addCriterion("action_dire >=", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireLessThan(Integer value) {
            addCriterion("action_dire <", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireLessThanOrEqualTo(Integer value) {
            addCriterion("action_dire <=", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIn(List<Integer> values) {
            addCriterion("action_dire in", values, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotIn(List<Integer> values) {
            addCriterion("action_dire not in", values, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireBetween(Integer value1, Integer value2) {
            addCriterion("action_dire between", value1, value2, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotBetween(Integer value1, Integer value2) {
            addCriterion("action_dire not between", value1, value2, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIsNull() {
            addCriterion("action_type is null");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIsNotNull() {
            addCriterion("action_type is not null");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeEqualTo(String value) {
            addCriterion("action_type =", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotEqualTo(String value) {
            addCriterion("action_type <>", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeGreaterThan(String value) {
            addCriterion("action_type >", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeGreaterThanOrEqualTo(String value) {
            addCriterion("action_type >=", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLessThan(String value) {
            addCriterion("action_type <", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLessThanOrEqualTo(String value) {
            addCriterion("action_type <=", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLike(String value) {
            addCriterion("action_type like", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotLike(String value) {
            addCriterion("action_type not like", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIn(List<String> values) {
            addCriterion("action_type in", values, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotIn(List<String> values) {
            addCriterion("action_type not in", values, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeBetween(String value1, String value2) {
            addCriterion("action_type between", value1, value2, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotBetween(String value1, String value2) {
            addCriterion("action_type not between", value1, value2, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIsNull() {
            addCriterion("supplier is null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIsNotNull() {
            addCriterion("supplier is not null");
            return (Criteria) this;
        }
        
        public Criteria andSupplierEqualTo(Integer value) {
            addCriterion("supplier =", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotEqualTo(Integer value) {
            addCriterion("supplier <>", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierGreaterThan(Integer value) {
            addCriterion("supplier >", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierGreaterThanOrEqualTo(Integer value) {
            addCriterion("supplier >=", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierLessThan(Integer value) {
            addCriterion("supplier <", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierLessThanOrEqualTo(Integer value) {
            addCriterion("supplier <=", value, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierIn(List<Integer> values) {
            addCriterion("supplier in", values, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotIn(List<Integer> values) {
            addCriterion("supplier not in", values, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierBetween(Integer value1, Integer value2) {
            addCriterion("supplier between", value1, value2, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andSupplierNotBetween(Integer value1, Integer value2) {
            addCriterion("supplier not between", value1, value2, "supplier");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdIsNull() {
            addCriterion("uniq_id is null");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdIsNotNull() {
            addCriterion("uniq_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdEqualTo(String value) {
            addCriterion("uniq_id =", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdNotEqualTo(String value) {
            addCriterion("uniq_id <>", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdGreaterThan(String value) {
            addCriterion("uniq_id >", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdGreaterThanOrEqualTo(String value) {
            addCriterion("uniq_id >=", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdLessThan(String value) {
            addCriterion("uniq_id <", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdLessThanOrEqualTo(String value) {
            addCriterion("uniq_id <=", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdLike(String value) {
            addCriterion("uniq_id like", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdNotLike(String value) {
            addCriterion("uniq_id not like", value, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdIn(List<String> values) {
            addCriterion("uniq_id in", values, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdNotIn(List<String> values) {
            addCriterion("uniq_id not in", values, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdBetween(String value1, String value2) {
            addCriterion("uniq_id between", value1, value2, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andUniqIdNotBetween(String value1, String value2) {
            addCriterion("uniq_id not between", value1, value2, "uniqId");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIsNull() {
            addCriterion("created_time is null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIsNotNull() {
            addCriterion("created_time is not null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeEqualTo(Date value) {
            addCriterion("created_time =", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotEqualTo(Date value) {
            addCriterion("created_time <>", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeGreaterThan(Date value) {
            addCriterion("created_time >", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("created_time >=", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeLessThan(Date value) {
            addCriterion("created_time <", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeLessThanOrEqualTo(Date value) {
            addCriterion("created_time <=", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIn(List<Date> values) {
            addCriterion("created_time in", values, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotIn(List<Date> values) {
            addCriterion("created_time not in", values, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeBetween(Date value1, Date value2) {
            addCriterion("created_time between", value1, value2, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotBetween(Date value1, Date value2) {
            addCriterion("created_time not between", value1, value2, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }
    }
    
    public static class Criteria extends GeneratedCriteria {
        
        protected Criteria() {
            super();
        }
    }
    
    public static class Criterion {
        
        private String condition;
        
        private Object value;
        
        private Object secondValue;
        
        private boolean noValue;
        
        private boolean singleValue;
        
        private boolean betweenValue;
        
        private boolean listValue;
        
        private String typeHandler;
        
        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }
        
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }
        
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }
        
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }
        
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
        
        public String getCondition() {
            return condition;
        }
        
        public Object getValue() {
            return value;
        }
        
        public Object getSecondValue() {
            return secondValue;
        }
        
        public boolean isNoValue() {
            return noValue;
        }
        
        public boolean isSingleValue() {
            return singleValue;
        }
        
        public boolean isBetweenValue() {
            return betweenValue;
        }
        
        public boolean isListValue() {
            return listValue;
        }
        
        public String getTypeHandler() {
            return typeHandler;
        }
    }
}